using SignedDistanceField
using LinearAlgebra
using Test

@testset "Core" begin
    for acc in [nothing, :KDTree]
        s, x, y, z = sdfgen("cube.obj", 0.1; acceleration=acc)
        @test s[1,1,1] ≈ norm([0.1,0.1,0.1])
        @test s[1,1,12] ≈ norm([0.1,0.1,0.])
        @test s[1,12,12] ≈ 0.1
        @test s[12,1,12] ≈ 0.1
        @test s[12,12,1] ≈ 0.1
        @test s[2,12,12] ≈ 0.
        @test s[12,2,12] ≈ 0.
        @test s[12,12,2] ≈ 0.
        @test s[12,12,12] ≈ -1.
        sdf_to_vtk("sdf.vti", s, x, y, z)
        @test isfile("sdf.vti")
        rm("sdf.vti")
    end
end

@testset "Display" begin
    s, x, y, z = sdfgen("bunny.obj", 0.005)
    display_sdf(s, x, y, z)
    sleep(2)
end

